%undefine _python_bytecompile_errors_terminate_build

%global _docdir_fmt python3-zope-testrunner

Summary:        Zope testrunner script
Name:           python-zope-testrunner
Version:        6.0
Release:    2%{?dist}

License:        ZPL-2.1
URL:            https://pypi.python.org/pypi/zope.testrunner
Source0:        https://github.com/zopefoundation/zope.testrunner/archive/%{version}/zope.testrunner-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  help2man
BuildRequires:  python3-devel
BuildRequires:  python3-docs

%description
This package provides a flexible test runner with layer support.

%package     -n python3-zope-testrunner
Summary:        Zope testrunner script

%description -n python3-zope-testrunner
This package provides a flexible test runner with layer support.

%package        doc
License:        ZPL-2.1 AND BSD-2-Clause AND MIT
Summary:        Documentation for zope.testrunner

%description    doc
Documentation for zope.testrunner.

%package -n python3-zope-testrunner+subunit
Summary: Subpackage for python3-zope-testrunner with extra subunit dependencies
Requires: python3-zope-testrunner

%description -n python3-zope-testrunner+subunit
This is the subpackage for python3-zope-testrunner with extra subunit dependencies.

%files -n python3-zope-testrunner+subunit -f %{_pyproject_ghost_distinfo}


%prep
%autosetup -n zope.testrunner-%{version}

sed -i "s/'default'/'classic'/" docs/conf.py

sed -i 's/python -m/python3 -m/' docs/cli.rst

sed -i "s|\('https://docs\.python\.org/': \)None|\1'%{_docdir}/python3-docs/html/objects.inv'|" docs/conf.py

sed -i "s/autodoc_default_flags.*/autodoc_default_options = {'members': True, 'show-inheritance': True}/" docs/conf.py

%generate_buildrequires
%pyproject_buildrequires -t -x test,subunit,docs

%build
%pyproject_wheel

rst2html --no-datestamp CHANGES.rst CHANGES.html
rst2html --no-datestamp README.rst README.html

cp -p COPYRIGHT.rst COPYRIGHT

%install
%pyproject_install
mkdir -p %{buildroot}%{_mandir}/man1
PYTHONPATH=%{buildroot}%{python3_sitelib} \
help2man -s 1 -o %{buildroot}%{_mandir}/man1/zope-testrunner.1 \
  -N -n "Zope testrunner script" %{buildroot}%{_bindir}/zope-testrunner

mkdir lib
cp -a %{_prefix}/lib/python%{python3_version} lib
if [ -d %{_prefix}/lib64/python%{python3_version} ]; then
  mkdir lib64
  cp -a %{_prefix}/lib64/python%{python3_version} lib64
fi
mkdir include
cp -a %{_includedir}/python%{python3_version}* include
cp -a %{buildroot}%{python3_sitelib}/zope* \
      lib/python%{python3_version}/site-packages
export PYTHONHOME=$PWD:$PWD
sphinx-build -b html -d docs/_build/doctrees docs docs/_build/html
rm -fr include lib lib64
rm -f docs/_build/html/.buildinfo
unset PYTHONHOME

%check
pushd %{buildroot}%{python3_sitelib}
PURE_PYTHON=1 python3 -m unittest discover -s zope/testrunner -t .
popd

%files -n python3-zope-testrunner
%doc CHANGES.html README.html
%license COPYRIGHT LICENSE.md
%{_bindir}/zope-testrunner
%{_mandir}/man1/zope-testrunner.1*
%{python3_sitelib}/zope.testrunner*
%{python3_sitelib}/zope/testrunner/
%exclude %{python3_sitelib}/zope/testrunner/tests

%files doc
%doc docs/_build/html

%changelog
* Thu Jun 12 2025 bbrucezhang <bbrucezhang@tencent.com> - 6.0-2
- Rebuilt for loongarch64

* Fri Aug 23 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.0-1
- initial build
